'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
' Este arquivo define configuraes de tempo de compilao e declara opes globais.
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

'configuraes de vdeo e udio
const as double FOV = 60
const as double FOG_DIST = 640
const as integer BUFFER_VORBIS = 32768
const as double FATOR_DOPPLER = 40

'variveis configurveis por carregaCfg
dim shared as double aspect_ratio
dim shared as integer w, h, _dx_, _dy_, borda_hud, _
	FULLSCREEN, MAX_FPS, FILTERING_ON, WIREFRAME_ON, JOYSTICK_ON, USE_Y_AXIS, _
	SFX_ON, MUSICA_ON, VOL_MUSICA, HUD_ON, MIRROR_ON, LOD

'limites de memria
const as integer MAX_CARROS = 8
const as integer MAX_TECLAS = 24
const as integer MAX_SPRITEGFX = 11
const as integer MAX_SPRITES = 640
const as integer MAX_ESTRELAS = 1024
const as integer MAX_TRIANGULOS = 128
const as integer MAX_REPLAY_BUFFERS = 2048 'aprox. 34 segundos a 60fps
const as integer MAX_MUSICAS = 1

'rotinas
declare sub parseCfg (linha as string, nome_var as string, var_ptr as integer pointer)
declare sub carregaCfg

'***
'interpreta uma linha de arquivo de configurao e atribui uma varivel inteira
sub parseCfg (linha as string, nome_var as string, var_ptr as integer pointer)
	dim as string msg = ""
	dim as integer resultado
	
	'converte tudo para minsculas
	linha = lcase(linha)
	nome_var = lcase(nome_var)

	' comentrio?
	if left(linha, 1) = "#" or left(linha, 1) = "[" then exit sub

	'pesquisa se varivel est presente
	if instr(linha, nome_var) then
		'linha  bem formada?
		if instr(linha, "=") then		
			'isola valor
			linha = trim(linha)
			linha = ltrim(linha, nome_var)
			linha = ltrim(linha, any " =")
			
			'escreve valor
			if linha = "true" then
				resultado = true
			elseif linha = "false" then
				resultado = false
			else
				resultado = val(linha)
			end if
			
			*var_ptr = resultado
			msg = nome_var + " = " + str(resultado)
		else
			msg = nome_var + ": string mal formada: '=' faltando"
		end if
	end if
	
	'sada de debug
	if msg <> "" then print "parseCfg: "; msg
end sub

'***
sub carregaCfg
	dim as string linha

	'defaults
	w = 1024
	h = 600
	FULLSCREEN = false
	MAX_FPS = 60
	FILTERING_ON = true
	WIREFRAME_ON = false
	JOYSTICK_ON = false
	USE_Y_AXIS = true
	SFX_ON = true
	MUSICA_ON = true
	VOL_MUSICA = 64
	HUD_ON = true
	MIRROR_ON = true
	LOD = 3
	
	'abre arquivo
	open "road3d.cfg" for input as #1
		while not eof(1)
			line input #1, linha
			
			parseCfg linha, "wireframe", @WIREFRAME_ON
			parseCfg linha, "screen_w", @w
			parseCfg linha, "screen_h", @h
			parseCfg linha, "fullscreen", @FULLSCREEN
			parseCfg linha, "max_fps", @MAX_FPS
			parseCfg linha, "filtering", @FILTERING_ON
			parseCfg linha, "joystick", @JOYSTICK_ON
			parseCfg linha, "use_y_axis", @USE_Y_AXIS
			parseCfg linha, "sfx_on", @SFX_ON
			parseCfg linha, "music_on", @MUSICA_ON
			parseCfg linha, "music_volume", @VOL_MUSICA
		wend
	close #1
	
	'calcula outros valores
	aspect_ratio = w/h
	borda_hud = h * 0.04
	
	if w < 640 then
		_dx_ = 6
		_dy_ = 9
	elseif w < 1280 or h < 600 then
		_dx_ = 12
		_dy_ = 18
	else
		_dx_ = 18
		_dy_ = 27
	end if
	
	'confere joystick
	if getjoystick(0, , , ,) then
		print "Joystick nao encontrado! Revertendo para teclado."
		
		JOYSTICK_ON = false
	end if
end sub
