type framerate
	private:
		fator as double
		exibe as integer
		
		old_timer as double
		timer_dif as double
		
		max_fps as integer
	
	public:
		fps as double
	
		declare function getFator () as double
		declare function getFPS () as string
		declare function getMaxFPS () as integer
		declare sub setMaxFPS (max_fps as integer)
		
		declare sub reinicia
		declare sub atualiza
		declare sub preciseSleep
		
		declare function subtraiTempo (t as double) as double
end type

dim shared fps as framerate

'------------------------------------------------------------------------------------
function framerate.getFator as double
	return fator
end function

function framerate.getFPS as string
	return str(exibe)
end function

function framerate.getMaxFPS as integer
	return max_fps
end function

sub framerate.setMaxFPS (max_fps as integer)
	this.max_fps = max_fps
end sub

sub framerate.reinicia
	fator = 1
	old_timer = -1
	exibe = 0
end sub	

sub framerate.atualiza
	'calcula fator
	if old_timer = -1 then
		timer_dif = 1 / 50
	else
		timer_dif = timer - old_timer
	end if
		
	fps = 1 / timer_dif
	fator = 50 / fps
	
	'atualiza valor para exibir a cada segundo
	if (timer mod 2) <> (old_timer mod 2) then exibe = int(fps)
	
	'para o prximo ciclo
	old_timer = timer 	
end sub	

sub framerate.preciseSleep
	if max_fps <= 0 then exit sub

	dim as double intervalo, cron	'em segundos
	
	'calcula intervalo necessrio
	intervalo = (1 / max_fps) - (timer - old_timer)
	cron = timer
	
	do
		sleep 0, 1 'o negcio aqui  liberar tempo para o sistema e pegar de volta o mais rpido possvel
	loop until (timer - cron) > intervalo
end sub

function framerate.subtraiTempo (t as double) as double
	return edge(t - ((1000 / 50) * getFator), 0, 10000)
end function
